package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import java.io.*;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;
import java.util.TreeMap;
import java.util.Iterator;
import java.util.Set;
import re.jimmitry.apps974.wsfurious.xsd.*;
public class FurPRGM_1 {
public static boolean state = false;
public static boolean Backup() {
  boolean b = true;
  try {
    String[] str= {"-url", "jdbc:h2:tcp://localhost:9091,localhost:9092/DBSConnector", "-user", "sa", "-script", "dbsconnector.zip", "-options", "compression", "zip"};
    org.h2.tools.Script.main(str);
    Fur_File.Trace2("BACKUP H2: OK");
  } catch (Exception e) {
    Fur_File.Trace2("ERROR: FurPRGM_1.Backup: "+e.getMessage());
    b=false;
  }
  return b;
}
public static void ConnectionClose() {
  state=false;
}
public static void ConnectionOpen() {
  state=true;
}
public static boolean CreerConnection(String PaConnection, String PbTypeDB) {
  boolean b = true;
  String TempPort="";
  File f = new File("webapps/DBSConnector/Connections/"+PaConnection);
  File g = new File("webapps/DBSConnector/Connections/"+PaConnection+"/.Database");
  try {
    f.mkdir();
    g.createNewFile();
    FileWriter fw = new FileWriter(g);
    fw.write("[CNX]\n");
    fw.write("Type="+PbTypeDB+"\n");
    fw.write("Host=\n");
    if (PbTypeDB.equals("Oracle")) {
      TempPort="1521";
    }
    if (PbTypeDB.equals("MySQL")) {
      TempPort="3306";
    }
    if (PbTypeDB.equals("Advantage")) {
      TempPort="6262";
    }
    if (PbTypeDB.equals("MaxDB")) {
      TempPort="7210";
    }
    if (PbTypeDB.equals("PostgreSQL")) {
      TempPort="5432";
    }
    if (PbTypeDB.equals("HSQLDB")) {
      TempPort="9001";
    }
    if (PbTypeDB.equals("H2DB")) {
      TempPort="9092";
    }
    if (PbTypeDB.equals("McKoiDB")) {
      TempPort="9157";
    }
    if (PbTypeDB.equals("FireBird")) {
      TempPort="3050";
    }
    if (PbTypeDB.equals("SQLServer")) {
      TempPort="1433";
    }
    if (PbTypeDB.equals("DB2") || PbTypeDB.equals("Derby")) {
      TempPort="1527";
    }
    fw.write("Port="+TempPort+"\n");
    fw.write("BaseName=\n");
    fw.write("User=\n");
    fw.write("Password=\n");
    fw.write("Option=\n");
    fw.write("MaxPOOL=20\n");
    fw.write("MaxWaitForNew=10000\n");
    fw.flush();
    fw.close();
    
    VARIABLES vvv = null;
    VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=vvv;
    FurPRGM_9.STARTACTIVITY("__DEPLOY" ,"SELECTCONNECTION", vvv2);
  }
  catch (Exception e) { b = false; Fur_File.Trace("ERROR: FurPRGM_1.CreerConnection: "+e.getMessage());};
  return b;
};
public static boolean DelConnection(String PaConnection) {
  boolean b = Fur_File.deleteFileFolder("webapps/DBSConnector/Connections/"+PaConnection);
  if (FuriousPOOLS_SYS.PoolLIST.containsKey(PaConnection)) FuriousPOOLS_SYS.PoolLIST.remove(PaConnection);
  VARIABLES vvv = null;
  VARIABLES[] vvv2 = new VARIABLES[1]; vvv2[0]=vvv;
  FurPRGM_9.STARTACTIVITY("__DEPLOY" ,"SELECTCONNECTION", vvv2);
  return b;
}
public static boolean ExistConnection(String PaConnection) {
  if (PaConnection.equals("") || PaConnection==null) return false;
  else {
    File f = new File("webapps/DBSConnector/Connections/"+PaConnection);
    return f.exists();
  }
}
public static boolean ModifConnection(String PaConnection, String PbType, String PcHost, String PdPort, String PeDatabase, 
    String PfUser, String PhPassword,
    String PiMaxPOOL, String PjMaxWaitForNew, String PkOption) {
  boolean b = true;
  try {
    File g = new File("webapps/DBSConnector/Connections/"+PaConnection+"/.Database");
    g.delete();
    g.createNewFile();
    FileWriter fw = new FileWriter(g);
    fw.write("[CNX]\n");
    fw.write("Type="+PbType+"\n");
    fw.write("Host="+PcHost+"\n");
    fw.write("Port="+PdPort+"\n");
    fw.write("BaseName="+PeDatabase+"\n");
    fw.write("User="+PfUser+"\n");
    fw.write("Password="+PhPassword+"\n");
    fw.write("Option="+PkOption+"\n");
    fw.write("MaxPOOL="+PiMaxPOOL+"\n");
    fw.write("MaxWaitForNew="+PjMaxWaitForNew+"\n");
    fw.flush();
    fw.close();
    if (FuriousPOOLS_SYS.PoolLIST.containsKey(PaConnection)) FuriousPOOLS_SYS.PoolLIST.remove(PaConnection);
  }
  catch (Exception e) { b = false; Fur_File.Trace("ERROR: FurPRGM_1.ModifConnection: "+e.getMessage());};
  return b;
}
public static boolean Restore() {
  boolean b = true;
  try {
    String[] str= {"-url", "jdbc:h2:tcp://localhost:9091,localhost:9092/DBSConnector", "-user", "sa", "-script", "dbsconnector.zip", "-options", "compression", "zip"};
    org.h2.tools.RunScript.main(str);
    Fur_File.Trace2("RESTORE H2: OK");
  } catch (Exception e) {
    Fur_File.Trace2("ERROR: FurPRGM_1.Restore: "+e.getMessage());
    b=false;
  }
  return b;
}
public static void STOPALLDATABASE() {
  Map<String, FuriousPOOL_SYS> myTreeMap = new TreeMap<String, FuriousPOOL_SYS>(FuriousPOOLS_SYS.PoolLIST);
  Set myKeys = myTreeMap.keySet();
  Iterator myKeysIterator = null;
  File dirC = new File("webapps/DBSConnector/Connections");
  String[] Connections = dirC.list();
  java.util.Arrays.sort(Connections);
  for (int ii=0; ii<Connections.length; ii++) {
    String Connection = Connections[ii];
      myKeysIterator = myKeys.iterator();
      while (myKeysIterator.hasNext()) {
        String Key=(String) myKeysIterator.next();
        if (Key.equals(Connection)) {
          FuriousPOOL_SYS val= FuriousPOOLS_SYS.PoolLIST.get(Key);
          for(int i=0;i<val.Pool.length;i++) {
            if (val.Pool[i].CNX!=null) {
              try {val.Pool[i].CNX.close();
              val.Pool[i].Libre = true;
              val.Pool[i].Valide = false;
              val.Pool[i].TypeCNX = "";
              val.Pool[i].ErrorMessage = "";
              val.Pool[i].nbCall = 0;} catch (Exception j) {if (FurPARAM.getDBSConnectorParam("DBSC_VERBOSE").DATA.equals("True")) Fur_File.Trace("ERRORCLOSEConnection: FurPRGM_1.STOPALLDATABASE: Connection["+i+"/"+val.Pool.length+"]: "+Connection+"(Position="+i+")"+j.getMessage());};
            }
          }
        }
      }
    if (FuriousPOOLS_SYS.PoolLIST.containsKey(Connection)) FuriousPOOLS_SYS.PoolLIST.remove(Connection);
  }
}
public static boolean ValidConnection(String PaConnectionName) {
  return (!PaConnectionName.equals("") && Fur_String.isCharListStartWith(PaConnectionName, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz") 
  && Fur_String.isValidCharList(PaConnectionName, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"));
}
public static void changeStatePool() {
  if (state) state=false; else state=true;
}
}
